#include "input.h"

Input::Input(/* args */) : cap(0)
{
    const int VID_HEIGHT = 240;
    const int VID_WIDTH = 320;

    this->cap.set(CAP_PROP_FRAME_HEIGHT, VID_HEIGHT);
    this->cap.set(CAP_PROP_FRAME_WIDTH, VID_WIDTH);
}

Input::~Input()
{
    this->freeWebcam();
}

Mat Input::readFile(String filePath)
{
    std::srand(std::time(0));
    // Read all .jpg files from the specified folder
    std::string folder = filePath;
    std::vector<std::string> filenames;
    cv::glob(folder, filenames);

    // Random shuffle
    std::random_shuffle(filenames.begin(), filenames.end());

    Mat image = imread(filenames[0], IMREAD_COLOR);
    
    if(image.empty())
    {
        std::cout << "Could not read the image: " << filePath << std::endl;
        return Mat();
        //To do:Exception handeling
    }

    return image;
}

Mat Input::readWebcam()
{
    Mat image;

    if(!cap.isOpened()) {
        cout << "Fehler";
        return Mat();
    }

    cap.read(image);
    
    return image;  
}

void Input::freeWebcam()
{
    this->cap.release();
}